﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;

namespace CellGrid_2008
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            // this.gridControl1[2, 2].CellType = GridCellTypeName.DropDownGrid;
            //gridControl1.Model.CellModels.Add("DropDownCell", new CustomComboBox(gridControl1.Model));
            //gridControl1[2, 2].CellType = GridCellTypeName.DropDownGrid;
            this.gridControl1.Model.CellModels["ComboBox"] = new CustomComboBoxCellModel(this.gridControl1.Model);

            this.gridControl1.ColStyles[1].CellType = GridCellTypeName.ComboBox;
            
            this.gridControl1.CellClick += GridControl1_CellClick;
            StringCollection sc = new StringCollection();
            sc.AddRange(new String[] { "One", "Two", "Three", "Four", "Five" });
            this.gridControl1.ColStyles[1].ChoiceList = sc;
        }

        private void GridControl1_CellClick(object sender, GridCellClickEventArgs e)
        {

        }
    }

    public class CustomComboBoxCellModel : GridComboBoxCellModel
    {
        public CustomComboBoxCellModel(GridModel grid)
        : base(grid)
        {
            AllowFloating = false;
            ButtonBarSize = new Size(SystemInformation.VerticalScrollBarWidth, 0);
            SupportsChoiceList = true;
        }

        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new CustomComboBoxCellRenderer(control, this);
        }
        public override bool ApplyFormattedText(GridStyleInfo style, string text, int textInfo)
        {
            if (text.Length > 0 && text != null && (style.ChoiceList == null || style.ChoiceList.Count == 0))
            {
                if (style.DisplayMember != style.ValueMember)
                {
                    style.CellValue = text;
                    return true;
                }

            }
            return base.ApplyFormattedText(style, text, textInfo);
        }

    }

    public class CustomComboBoxCellRenderer : GridComboBoxCellRenderer
    {
        public CustomComboBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
        : base(grid, cellModel)
        {
            DropDownImp.InitFocusEditPart = true;
            DropDownButton = new GridCellComboBoxButton(this);
        }

        public override int FindItem(string prefix, bool selectItem, int start, bool ignoreCase)
        {
            ignoreCase = false;
            return base.FindItem(prefix, selectItem, start, ignoreCase);
        }
    }
}
